/* Dia -- an diagram creation/manipulation program
 * Copyright (C) 1998 Alexander Larsson
 *
 * Jackson diagram -  adapted by Christophe Ponsard
 * This class captures all kind of domains (given, designed, machine)
 * both for generic problems and for problem frames (ie. with domain kinds)
 *
 * based on SADT diagrams copyright (C) 2000, 2001 Cyrille Chepelov
 *
 * Forked from Flowchart toolpc -- objects for drawing flowcharts.
 * Copyright (C) 1999 James Henstridge.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <assert.h>
#include <math.h>
#include <string.h>
#include <glib.h>
#include "menace.h"

Propriete_Menace *copy_menace(gchar *label_menace,float action,float detection,float vulnerability)
{
  Propriete_Menace *propriete;
  propriete = g_new0(Propriete_Menace, 1);

  if (propriete->label != NULL)
    g_free(propriete->label);
  if (label_menace && label_menace[0])
    propriete->label = g_strdup (label_menace);
  else
    propriete->label = NULL;

  propriete->action=action;
  propriete->detection=detection;
  propriete->vulnerability=vulnerability;
  
//     fprintf(stderr,"espion create_new_propriete_autre fin\n");
  return propriete;

}

void create_new_proprietes_menace(gchar *label_menace, Propriete_Menace *propriete)
{
  if (propriete->label != NULL)
    g_free(propriete->label);
  
  if (label_menace && label_menace[0])
    propriete->label = g_strdup (label_menace);
  else
    propriete->label = NULL;
    
    propriete->action=propriete->detection=propriete->vulnerability=0.0f;
    //return propriete;
}

GList *create_list_proprietes_menace(GList *list_propriete_menace)
{

Propriete_Menace *propriete1,*propriete2,*propriete3,*propriete4,*propriete5,*propriete6,*propriete7,*propriete8,*propriete9,*propriete10;
Propriete_Menace *propriete11,*propriete12,*propriete13,*propriete14,*propriete15,*propriete16,*propriete17,*propriete18,*propriete19,*propriete20;
Propriete_Menace *propriete21,*propriete22,*propriete23,*propriete24,*propriete25,*propriete26,*propriete27,*propriete28,*propriete29,*propriete30;
Propriete_Menace *propriete31,*propriete32,*propriete33,*propriete34,*propriete35,*propriete36,*propriete37,*propriete38,*propriete39,*propriete40;
Propriete_Menace *propriete41,*propriete42;
//   fprintf(stderr,"espion create_list_proprietes_menace debut\t"); 
 propriete1 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Fire", propriete1);
 list_propriete_menace = g_list_prepend(list_propriete_menace, propriete1);
 
 propriete2 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Water damage",propriete2);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete2);

 propriete3 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Pollution",propriete3);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete3);

 propriete4 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Major accident",propriete4);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete4);

 propriete5 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Materials ou supports destroy",propriete5);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete5);

 propriete6 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Climate phenomen",propriete6);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete6);

 propriete7 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Seismic phenomen",propriete7);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete7);

 propriete8 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Volcanic phenomen",propriete8);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete8);

 propriete9 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Phenomene meteorological",propriete9);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete9);

 propriete10 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Rise in the water level",propriete10);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete10);
 
 propriete11 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Climatisation problem",propriete11);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete11);

 propriete12 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Electrique power problem",propriete12);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete12);

 propriete13 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Telecommunication problem",propriete13);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete13);

 propriete14 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Electromagnetic radiance",propriete14);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete14);

 propriete15 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Thermic radiance",propriete15);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete15);

 propriete16 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Electromagnetic impulse",propriete16);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete16);

 propriete17 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Interception de signaux parasites compromettants",propriete17);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete17);

 propriete18 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Espionnage a distance",propriete18);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete18);

 propriete19 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Ecoute passive",propriete19);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete19);

 propriete20 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Vol de supports ou de documents",propriete20);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete20);

 propriete21 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Vol de materiels",propriete21);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete21);

 propriete22 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Recuperation de supports recycles ou mis au rebus",propriete22);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete22);

 propriete23 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Divulgation",propriete23);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete23);

 propriete24 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Informations sans garantie de l'origine",propriete24);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete24);

 propriete25 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Piegeage du materiel",propriete25);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete25);

 propriete26 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Piegeage du logiciel",propriete26);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete26);

 propriete27 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Geolocalisation",propriete27);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete27);

 propriete28 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Panne materielle",propriete28);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete28);

 propriete29 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Dysfonctionnement du materiel",propriete29);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete29);

 propriete30 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Saturation du systeme informatique",propriete30);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete30);

 propriete31 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Dysfonctionnement logiciel",propriete31);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete31);

 propriete32 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Atteinte sur  maintenabilite systeme d'information",propriete32);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete32);

 propriete33 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Utilisation illicite des materiels",propriete33);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete33);

 propriete34 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Copie frauduleuse de logiciels",propriete34);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete34);

 propriete35 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Utilisation de logiciels contrefaits ou copies",propriete35);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete35);

 propriete36 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Alteration des donnees",propriete36);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete36);

 propriete37 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Traitement illicite des donnees",propriete37);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete37);

 propriete38 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Erreur d'utilisation",propriete38);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete38);

 propriete39 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Abus de droit",propriete39);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete39);

 propriete40 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Usurpation de droit",propriete40);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete40);

 propriete41 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Reniements d'actions",propriete41);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete41);

 propriete42 = g_malloc0(sizeof(Propriete_Menace));
 create_new_proprietes_menace("Atteinte sur disponibilite du personnel",propriete42);
 list_propriete_menace = g_list_append(list_propriete_menace, propriete42);
//   fprintf(stderr,"espion create_list_proprietes_menace fin\n"); 
  return list_propriete_menace;
}

GList *vidage_liste_propriete_menace (GList *list)
{  
  while (list != NULL) {
    Propriete_Menace *propriete_menace = (Propriete_Menace *) list->data;
    g_free(propriete_menace->label);
//     g_free(propriete_menace->action);
//     g_free(propriete_menace->detection);
//     g_free(propriete_menace->vulnerability);
    g_free(propriete_menace);
    list = g_list_next(list);
  }
  g_list_free(list);
  return list;
}

GList *vidage_liste_propriete_menace_widget (GList *list)
{  
  while (list != NULL) {
    Propriete_Menace_Widget *propriete_menace = (Propriete_Menace_Widget *) list->data;
    gtk_widget_destroy(propriete_menace->label);
    gtk_widget_destroy(propriete_menace->action);
    gtk_widget_destroy(propriete_menace->detection);
    gtk_widget_destroy(propriete_menace->vulnerability);
    g_free(propriete_menace);
    list = g_list_next(list);
  }
  g_list_free(list);
  return list;
}